<template>
  <div>
    <div class="search">
      <div class="search-input">
        <label class="search-input--label" for="searchInput">Search</label>
        <el-input id="searchInput" v-model="searchInput" placeholder="Search" />
      </div>
      <el-button @click="clickAddUser()" size="medium">Add</el-button>
    </div>
    <el-table :data="userFiltered" border style="width: 100%">
      <el-table-column prop="name" label="Name" width="180" />
      <el-table-column prop="email" label="Email" width="180" />
      <el-table-column prop="role.name" label="Roles" />
      <el-table-column prop="createdDate" label="Created Date" width="180">
        <template #default="scope">
          <div>
            <span>{{ formatDate(scope.row.createdDate) }}</span>
          </div>
        </template>
      </el-table-column>
      <el-table-column prop="lastDate" label="Last Date" width="180">
        <template #default="scope">
          <div>
            <span>{{ formatDate(scope.row.lastDate) }}</span>
          </div>
        </template>
      </el-table-column>
      <el-table-column prop="isDeleted" label="Deleted" width="180">
        <template #default="scope">
          <div>
            <span>{{ upperCaseFirstLetter(scope.row.isDeleted) }}</span>
          </div>
        </template>
      </el-table-column>
      <el-table-column align="right">
        <template #header>
          <div>
            <span>Actions</span>
          </div>
        </template>
        <template #default="scope">
          <el-button size="small" @click="clickEditUser(scope.row)">Edit</el-button>
          <el-button size="small" type="danger" @click="clickDeleteUser(scope.row.id)"
            >Delete</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-dialog v-model="visibleModal" :title="isCreating ? 'Add User' : 'Edit User'" width="30%">
      <div>
        <el-form :model="currentUserInfo" label-width="100px">
          <el-form-item label="Name">
            <el-input v-model="currentUserInfo.name" />
          </el-form-item>
          <el-form-item label="Email">
            <el-input v-model="currentUserInfo.email" />
          </el-form-item>
          <el-form-item label="Password">
            <el-input type="password" v-model="currentUserInfo.password" />
          </el-form-item>
          <el-form-item label="Roles">
            <!-- <el-input v-model="currentUserInfo.roleId" /> -->
            <el-select
              v-model="currentUserInfo.roleId"
              class="m-2"
              placeholder="Select Role"
              size="medium"
            >
              <el-option
                v-for="item in roleOptions"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
        </el-form>
      </div>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="visibleModal = false">Cancel</el-button>
          <el-button type="primary" @click="handleAddUser()"> Add </el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>
<script lang="ts">
import { computed, reactive, ref, watch } from 'vue'
import moment from 'moment'
import { useUserStore } from '@/stores/user'
import { type UserInfo } from '@/interfaces/user'
import { ElLoading } from 'element-plus'
import { useSpinnerStore } from '@/stores/spinner'
import { useToast } from 'vue-toast-notification'
export default {
  name: 'USer',
  setup() {
    const $toast = useToast()
    const searchInput = ref<string>('')
    const isCreating = ref<boolean>(true)
    const visibleModal = ref<boolean>(false)

    let currentUserInfo = reactive<UserInfo>({
      name: '',
      email: '',
      roleId: null,
      password: ''
    })

    const userStore = useUserStore()
    const spinnerStore = useSpinnerStore()
    watch(
      () => spinnerStore.spinner,
      (newVal) => {
        const loading = ElLoading.service({
          lock: true,
          text: 'Loading',
          background: 'rgba(0, 0, 0, 0.7)'
        })
        if (!newVal) {
          loading.close()
        }
      }
    )

    const userFiltered = computed(() => {
      const search = searchInput.value.trim().toLowerCase()
      return !searchInput.value.length
        ? userStore.userList
        : userStore.userList.filter(
            (p: UserInfo) =>
              p.name.toLowerCase().includes(search) || p.email.toLowerCase().includes(search)
          )
    })

    const roleOptions = computed(() => {
      return userStore.userRoleList.map((p: any) => {
        return {
          value: p.id,
          label: p.name
        }
      })
    })

    const formatDate = (date: string) => moment(date).format('YYYY-MM-DD')
    const upperCaseFirstLetter = (word: any) => {
      word = word.toString()
      return word[0].toUpperCase() + word.substr(1)
    }
    const handleAddUser = async () => {
      try {
        await userStore.addUser({
          payload: {
            ...currentUserInfo
          }
        })
        visibleModal.value = false
      } catch (error) {
        visibleModal.value = false
        $toast.open({
          message: 'Add user failed!',
          type: 'error',
          position: 'top'
        })
      }
    }

    const clickAddUser = (): void => {
      visibleModal.value = true
      isCreating.value = true
    }
    const clickEditUser = (user: any) => {
      isCreating.value = false
      visibleModal.value = true
      currentUserInfo.name = user.name
      currentUserInfo.email = user.email
      currentUserInfo.roleId = user.roleId
    }
    const clickDeleteUser = (id: string) => {
      handleDeleteUser(id)
    }

    const handleDeleteUser = async (id: string): Promise<void> => {
      try {
        userStore.deleteUser({ id })
      } catch (error) {
        console.log(error)
      }
    }

    userStore.getUserList()
    userStore.getUserRole()

    return {
      currentUserInfo,
      userFiltered,
      searchInput,
      formatDate,
      upperCaseFirstLetter,
      handleAddUser,
      clickEditUser,
      clickDeleteUser,
      visibleModal,
      roleOptions,
      isCreating,
      clickAddUser
    }
  }
}
</script>
<style scoped lang="scss">
.search {
  display: flex;
  align-items: center;
  justify-content: space-between;
  .search-input {
    display: flex;
    align-items: center;
    width: 50%;
    margin: 24px 0px;

    .search-input--label {
      margin-right: 5px;
    }
  }
}
</style>
